SystemOrganization addCategory: #'Croquet-Harness'!

Object subclass: #CroquetEvent
	instanceVariableNames: 'userID buttons keyValue selection avatarID camera timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Harness'!

!CroquetEvent commentStamp: 'das 4/20/2006 12:43' prior: 0!
The CroquetEvent includes a complete description of a user event including which mouse and keyboard buttons have been selected, a complete description of the 3D target objects inside of the selection, and the avatarID. It is the object passed to the Croquet objects to act upon when an event occurs.

The shiftPressed instance variable is there because the mouse scrollwheel does not return the correct value of the shift key. This requires a fix of the VM at some later date.

DAS!

!CroquetEvent class methodsFor: 'constants' stamp: 'das 12/21/2005 22:44'!
anyButton
	^ 7! !

!CroquetEvent class methodsFor: 'constants' stamp: 'das 12/21/2005 22:44'!
blueButton
	^ 1! !

!CroquetEvent class methodsFor: 'islands' stamp: 'ar 12/28/2005 18:59'!
howToPassAsArgument
	^#passByClone:! !

!CroquetEvent class methodsFor: 'constants' stamp: 'das 12/21/2005 22:44'!
redButton
	^ 4! !

!CroquetEvent class methodsFor: 'constants' stamp: 'das 12/21/2005 22:44'!
yellowButton
	^ 2! !

!CroquetEvent methodsFor: 'button state' stamp: 'das 12/21/2005 22:37'!
anyButtonPressed
	"Answer true if any mouse button is being pressed."

	^ buttons anyMask: self class anyButton! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 12/21/2005 22:35'!
anyModifierKeyPressed
	"ignore, however, the shift keys 'cause that's not REALLY a command key "

	^ self buttons anyMask: 16r70	"cmd | opt | ctrl"! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 2/2/2006 22:10'!
avatar
	^avatarID ifNotNil:[self island lookup: avatarID]! !

!CroquetEvent methodsFor: 'accessing' stamp: 'bgf 7/19/2006 18:19'!
avatar: atar
	avatarID := atar ifNotNil:[atar get: #objectID].! !

!CroquetEvent methodsFor: 'button state' stamp: 'das 12/21/2005 22:37'!
blueButtonPressed
	"Answer true if the blue mouse button is being pressed. This is the third mouse button or cmd+click on the Mac."

	^ buttons anyMask: self class blueButton! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 12/21/2005 22:35'!
buttons
	"Return the a word encoding the mouse and modifier buttons for this event."

	^ buttons! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 12/21/2005 22:43'!
buttons: bttns
	"Set the a word encoding the mouse and modifier buttons for this event."

	buttons := bttns.! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 4/19/2006 11:53'!
camera

	^ camera.! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 4/19/2006 11:53'!
camera: cam

	camera := cam.! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:55'!
cameraTransform

	^ selection cameraTransform.! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 5/25/2006 15:06'!
ck
	"Answer true if the control key on the keyboard was being held down when this event occurred."

	^ buttons .
! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 12/21/2005 22:36'!
commandKeyPressed
	"Answer true if the command key on the keyboard was being held down when this event occurred."

	^ buttons anyMask: 64! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 7/17/2006 20:33'!
commandKeyPressed: aBool

	buttons := aBool ifTrue:[buttons bitOr: 64] ifFalse:[buttons bitClear: 64]! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 7/17/2006 20:32'!
controlKeyPressed
	"Answer true if the control key on the keyboard was being held down when this event occurred."
	^buttons anyMask: 16! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 7/17/2006 20:33'!
controlKeyPressed: cp

	buttons := cp ifTrue:[buttons bitOr: 16] ifFalse:[buttons bitClear: 16].! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:55'!
distance

	^ selection distance.! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:55'!
distanceSquared

	^ selection distanceSquared.! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:56'!
frame

	^ selection frame! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:56'!
framePosition

	^ selection framePosition! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:56'!
index

	^ selection index! !

!CroquetEvent methodsFor: 'initialize' stamp: 'ar 7/18/2006 10:52'!
initialize
	"Initialize the receiver"
	buttons := 0.
	keyValue := 0.
	timeStamp := 0.! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 1/29/2006 15:08'!
keyCharacter
	"Answer the character corresponding this keystroke. This is defined only for keystroke events."

	^ keyValue asCharacter! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 1/7/2006 15:12'!
keyValue
	^keyValue! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 12/22/2005 00:51'!
keyValue: kval

	keyValue := kval.! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 5/25/2006 15:33'!
makePointer

	| pointer |
	pointer := TRay new.
	pointer globalTransform: (selection cameraTransform composeWith: selection rayTransform ).
	pointer frameScale: selection scale.
	^ pointer.! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:56'!
normal

	^ selection normal! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:57'!
parent

	^ selection parent! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:58'!
point

	^ selection point! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:58'!
portal

	^ selection portal.! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:58'!
portalPoint

	^ selection portalPoint.! !

!CroquetEvent methodsFor: 'button state' stamp: 'das 12/21/2005 22:37'!
redButtonPressed
	"Answer true if the red mouse button is being pressed. This is the first mouse button."

	^ buttons anyMask: self class redButton! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 1/7/2006 15:05'!
selection

	^selection! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 12/22/2005 00:48'!
selection: sel

	selection := sel.! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 7/17/2006 20:31'!
shiftPressed
	"Answer true if the shift key on the keyboard was being held down when this event occurred."
	^buttons anyMask: 8! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 7/17/2006 20:32'!
shiftPressed: sp
	buttons := sp ifTrue:[buttons bitOr: 8] ifFalse:[buttons bitClear: 8].! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 1/21/2006 15:09'!
target

	^ selection target! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 7/17/2006 20:15'!
timeStamp
	^timeStamp! !

!CroquetEvent methodsFor: 'accessing' stamp: 'ar 7/17/2006 20:15'!
timeStamp: aNumber
	timeStamp := aNumber! !

!CroquetEvent methodsFor: 'selection' stamp: 'das 12/21/2005 22:59'!
triangle

	^ selection triangle! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 12/21/2005 22:41'!
userID

	^ userID.! !

!CroquetEvent methodsFor: 'accessing' stamp: 'das 12/21/2005 22:41'!
userID: uid

	userID := uid.! !

!CroquetEvent methodsFor: 'button state' stamp: 'das 12/21/2005 22:37'!
yellowButtonPressed
	"Answer true if the yellow mouse button is being pressed. This is the second mouse button or option+click on the Mac."

	^ buttons anyMask: self class yellowButton! !

!Morph methodsFor: '*Croquet-Harness' stamp: 'ar 3/22/2006 15:51'!
glRenderOn: glx
	"Backstop. Do nothing."! !

Object subclass: #CroquetHarness
	instanceVariableNames: 'myEventMap userID dispatcher controllers contactPoint formMgr cacheMgr avatar ogl viewPortal postcard bounds systemOverlayPortal systemOverlay systemIsland readyToRender renderProcess doRender viewpoints eventPointer event yellowButtonPressed redButtonPressed overlays islandsByName islandsByID enableIslandCache snapshots windowData task taskStack lastCameraTransform activeSpace allowControllerAliasing embeddedApps'
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants'
	category: 'Croquet-Harness'!

!CroquetHarness commentStamp: '<historical>' prior: 0!
Croquet Harness is the minimal interface to the underlying support infrastructure. It is used to manage changes in screen real estate, and track events to vector to Croquet. 

userID - a unique TObjectID which identifies a particular user.
dispatcher -
controllers - collection of controllers that we have created that are connected to both the local and remote routers.
contactPoint - finds all of the local broadcasting routers via their own contectPoints.
formMgr - the default TFormManager. used to manage TForms.
cacheMgr - default TFileCachManager.
avatar - TAvatarUser
ogl - the OpenGL object, which is the interface to OpenGL.
viewPortal - the main viewing portal into the current space of interest
postcard - a TPostcard that is a reference for the rendered viewpoint.
bounds - the 2D bounds of the viewing space
systemOverlayPortal - overlay portal supporting the system overlay space
systemOverlay - system overlay space
systemIsland - the non-replicated Island containing the system overlay content
readyToRender - semaphore flag indicating that we can now render
renderProcess - a render process fork.
doRender - boolean indicating we can begin rendering
viewPoints - a listing of all the FarRe f viewpoints that are referenced by portals.
eventPointer - a TPointer used during rendering to determine user interactions with 3D objects.
event - a CroquetEvent object used to pass events to event processing objects inside of Croquet
yellowButtonPressed - boolean indicating yellow mouse button is pressed.
redButtonPressed - boolean indicating red mouse button is pressed.
overlays - array of overlay spaces passed to system to be rendered.
islandsByName - Dictionary used to look up Croquet Islands by their name.
islandsByID - Dictionary used to look up Croquet Islands by their ID.
enableIslandCache - enables checkpoint caching of Islands to disk.
snapshots - create image snapshots of current space.
windowData - holds a copy of a generic TWindow.

DAS!

!CroquetHarness class methodsFor: 'class initialization' stamp: 'das 8/18/2006 15:44'!
cleanup

3 timesRepeat:[
	Processor activeIsland flushGlobals.
	Transcript show:(TIsland allInstances do:[:i | i flushGlobals.]);cr. 
	Transcript show:(TFarRef allInstances do:[:fr | fr destroy]);cr.
	Transcript show:(CroquetHarness allInstances do:[:ch | ch destroy]);cr.
	Transcript show:(TAvatarUser allInstances do:[:au | au destroy]);cr.
	Transcript show:(TSimpleController allInstances do:[:sc | sc destroy]);cr.
	Transcript show:(ScriptMessageSend allInstances do:[:sms | sms terminateScript]);cr.
	Transcript show:(Smalltalk garbageCollect);cr.
]
! !

!CroquetHarness class methodsFor: 'class initialization' stamp: 'ar 2/3/2006 18:13'!
initialize
	"CroquetHarness initialize"
	IslandArgumentCopier initialize.
	Smalltalk addToShutDownList: self.! !

!CroquetHarness class methodsFor: 'class initialization' stamp: 'das 2/4/2006 11:50'!
shutDown: quitting
	TFormManager default destroy.
	TFormManager default: nil.! !

!CroquetHarness methodsFor: 'render' stamp: 'bgf 6/12/2006 13:08'!
aboutToRender

	"This is an extension hook for subclasses.
      Called in each render cycle, after avatar/camera position update 
	 and just before the render: treewalk of the visible frame tree.
	 It is called during the locked-down phase of render,
	 so methods should be quick and may not change the replicated state.
	 (Originally used to update the avatar's OpenAL listener position
	 in the audio harness to match the avatar's current spatial position.)"

	self signal: #aboutToRender.! !

!CroquetHarness methodsFor: 'islands' stamp: 'ar 1/13/2006 11:11'!
activeIsland
	"Answer the island we're currently on"
	^self activeSpace island! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 2/2/2006 00:15'!
activeSpace
	"Answer the space we're currently in"
	^self findViewpointByPostcard: (viewPortal get: #postcardLink).! !

!CroquetHarness methodsFor: 'accessing' stamp: 'sn 2/26/2018 14:57'!
addController: aController
	aController cacheManager: cacheMgr.
	controllers add: aController.
	"self updateEmbeddedAppsIn: aController island."
! !

!CroquetHarness methodsFor: 'islands' stamp: 'bgf 3/21/2006 14:50'!
addIsland: isl postcard: pc

	| key |
	(key := pc routerName) ifNotNil:[islandsByName at: key put: isl].
	(key := pc routerID) ifNotNil:[islandsByID at: key put: isl].
! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/6/2006 22:35'!
addOverlay: overlay
	overlays := overlays copyWith: overlay.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 9/1/2006 15:52'!
allowControllerAliasing
	^allowControllerAliasing! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 9/1/2006 15:52'!
allowControllerAliasing: aBool
	allowControllerAliasing := aBool! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/15/2006 00:42'!
avatar
	^avatar! !

!CroquetHarness methodsFor: 'accessing' stamp: 'bgf 7/19/2006 18:19'!
avatar: aTAvatarUser
	avatar := aTAvatarUser.
	avatar userID: userID.! !

!CroquetHarness methodsFor: 'render' stamp: 'ar 2/23/2006 15:57'!
bounds
	^bounds! !

!CroquetHarness methodsFor: 'render' stamp: 'das 5/1/2006 18:47'!
bounds: bnds
	

	| xform |

	ogl ifNil:[
		ogl := OpenGL newIn: bnds. 	
		ogl ifNil: [self error: 'Cannot initialize OpenGL.' ].
		ogl harness: self.
		ogl formManager: TFormManager default.
	] ifNotNil:[ 
		xform := ogl camera ifNotNil: [ogl camera localTransform.].
		ogl := ogl bufferRect: bnds. 
	].

	bounds := bnds  translateBy: bnds origin negated.
	ogl camera: TCamera new.
	ogl avatar: avatar.
	ogl camera bounds: bounds.
	xform ifNotNil:[ ogl camera localTransform: xform.].
	ogl camera initFrustum: ogl.
	eventPointer parent: ogl camera.
	viewPortal ifNotNil:[viewPortal send:[ :vp | vp bounds: bounds.]].
	systemOverlayPortal ifNotNil:[systemOverlayPortal send:[ :so | (so resolveViewpoint:ogl) send:[ :spc | spc bounds: bounds.].].].
! !

!CroquetHarness methodsFor: 'render' stamp: 'das 5/1/2006 18:47'!
bounds: bnds subBounds: sbnds
	
	| sbounds |
	ogl ifNil:[
		ogl := OpenGL newIn: bnds. 	
		ogl harness: self.
		ogl formManager: TFormManager default.
	] ifNotNil:[ ogl := ogl bufferRect: bnds. ].

	bounds := bnds  translateBy: bnds origin negated.
	sbounds := sbnds  translateBy: sbnds origin negated.
	ogl camera: TCamera new.
	ogl avatar: avatar.
	ogl camera bounds: bounds.
	ogl camera subBounds: sbounds.
	ogl camera initFrustum: ogl.
	eventPointer parent: ogl camera.
	viewPortal ifNotNil:[viewPortal send:[ :vp | vp bounds: bounds.]].
	systemOverlayPortal ifNotNil:[systemOverlayPortal send:[ :so | (so resolveViewpoint:ogl) send:[ :spc | spc bounds: bounds.].].].! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/20/2006 15:46'!
cacheDirectory
	| fd |
	fd := FileDirectory default directoryNamed: 'cache'.
	fd assureExistence.
	^fd! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/30/2006 12:38'!
cacheManager
	^cacheMgr! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/30/2006 12:39'!
cacheManager: aCacheManager
	cacheMgr := aCacheManager! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/7/2006 19:48'!
camera
	^ogl camera! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 5/24/2006 15:53'!
contactPoint
	^contactPoint! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/31/2006 17:25'!
contactsByID
	^contactPoint contactsByID! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/31/2006 17:25'!
contactsByName
	^contactPoint contactsByName! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 9/21/2006 17:32'!
controllers
	^controllers! !

!CroquetHarness methodsFor: 'initialize' stamp: 'sn 2/26/2018 15:22'!
createIsland: islandClass named: aString
	"Create a new island. islandClass must be a class that is used to generate the contents of the TIsland. aString is a name for the router/island that allows another user to identify it. aBlock is executed upon completion and existence of the island. This is used to do additional setup with the island."
	| p router controller id|
	id := islandClass islandID.

	"if a controller for this island has already been registered, just use that"
	allowControllerAliasing ifTrue:[
		controller := controllers detect:[:cc| cc sessionID = id and:[cc island == nil]] ifNone:[nil].
		controller ifNotNil:[^self createIsland: islandClass named: aString using: controller].
	].

	"Create the dispatcher for any local islands we'd like to host the router for"
	dispatcher ifNil:[
		dispatcher := TExampleDispatcher new.
		dispatcher listenOn: 0. "wildcard port"
		dispatcher autoCreate: false.
	].
	"@@@@ FIXME: This is clearly not the way to do it @@@@"
	router := TSimpleRouter new.
	false ifTrue:[router log: Transcript].
	router addUserName: 'foo' password: 'bar'.
	dispatcher addRouter: router id: id.
	
	contactPoint ifNil:[contactPoint := TContactPointWS new].
	
	contactPoint addBroadcast:(TContact new 
		address: dispatcher address port: dispatcher port 
		id: id name: aString).

	"Create the controller"
	controller := TSimpleController new.
	controller connectTo: dispatcher address port: dispatcher port sessionID: id.
	self addController: controller.
	p := controller login: 'foo' password: 'bar'.
	p wait. "not good style but easier for the setup"
	p := controller join.			"receive messages"
	p wait. "see above"
	controller backDoor: (dispatcher routers at: id).
	^self createIsland: islandClass named: aString using: controller! !

!CroquetHarness methodsFor: 'initialize' stamp: 'sn 2/26/2018 14:57'!
createIsland: islandClass named: aString using: controller
	"Create a new island. islandClass must be a class that is used to generate the contents of the TIsland. aString is a name for the router/island that allows another user to identify it. controller is the controller to use for the island"
	| island id fileName file data sync p |
	id := islandClass islandID.
	controller heartbeat: 20.
	controller beServer.	"act as server"

	"Decide whether we need to recreate the island"
	self enableIslandCache ifTrue:[
		fileName := islandClass name,'.c3d'.
		file := [self cacheDirectory readOnlyFileNamed: fileName] 
			on: FileDoesNotExistException 
			do:[:ex| ex return: nil].
		file ifNotNil:[
			"Load island from file"
			file binary.
			[data := file contents] ensure:[file close].
			island := [controller restore: data] on: Error do:[:ex|
				(UIManager default 
					chooseFrom: #('Ignore' 'Debug') 
					title: 'Could not load ', fileName,':\' withCRs, ex description) = 2
						ifTrue:[Processor activeProcess debug: ex signalerContext 
									title: ex description  full: true].
				ex return: nil.
			].
			island ifNotNil:[
				"Ask the controller to update the router's time stamp"
				p := controller routerStamp: (island get: #time).
				p wait. "until the new time base is in effect"
			].
		].
	].
	island ifNotNil:[controller island: island].
	island ifNil:[
		"Create a new island"
		island := controller newIsland. "Create a new island handled by the controller"
		"the island must have the same id/name as the router to generate postcards"
		island future id: id name: aString. 
		sync := island future new: islandClass.
		self enableIslandCache ifTrue:[
			sync wait.
			"Make sure we don't interfere with render - render may hold a lock on the island which will not get released since this is the main thread being expected to signal readyToRender. Therefore we signal readyToRender right here to force it to render if a render operation was pending (if not, we fall right through this code)."
			readyToRender signal.
			readyToRender wait.
			data := controller snapshot.
			file := self cacheDirectory forceNewFileNamed: fileName.
			file binary.
			[file nextPutAll: data] ensure:[file close].
		].
	].
	"self updateEmbeddedAppsIn: island."
	islandsByName at: aString put: island.
	islandsByID at: id put: island.

	^island! !

!CroquetHarness methodsFor: 'initialize' stamp: 'sn 2/23/2018 13:49'!
destroy

	"embeddedApps do:[:app| app destroy]."
	ogl ifNotNil:[ogl destroy].
	ogl := nil.
	controllers ifNotNil:[
		controllers do:[:each| each destroy. ].
	].
	controllers := nil.
	contactPoint ifNotNil:[contactPoint destroy].
	dispatcher ifNotNil:[dispatcher destroy].! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 4/24/2006 19:11'!
dispatcher
	^dispatcher! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 4/24/2006 19:11'!
dispatcher: aDispatcher
	dispatcher := aDispatcher! !

!CroquetHarness methodsFor: 'render' stamp: 'das 12/2/2005 09:30'!
doRender

	^ doRender.! !

!CroquetHarness methodsFor: 'event handling' stamp: 'ar 1/12/2006 18:56'!
dropFile: aFile
	"Handle a file dropped via the OS"
	| form |
	form := Form fromBinaryStream: aFile.
	^self dropForm: form! !

!CroquetHarness methodsFor: 'event handling' stamp: 'ar 2/16/2006 22:27'!
dropForm: aForm
	"Drop aForm in front of the camera"
	| space island txtr tform aPosition size mat wnd |
	size := aForm extent * 0.01.
	"Grab both space and island"
	space := self activeSpace.
	island := self activeIsland.
	tform := island future new: TForm.
	tform future initialize: nil form: aForm mipmap: true shrinkFit: true extension: nil.
	txtr := island future new: TTexture.
	txtr future initializeWithTForm: tform.
	txtr future aspect: size y / size x asFloat. 
	txtr future extent: size.

	mat := island future new: TMaterial.
	mat future ambientColor: #(1 1 1 0.99) asFloatArray.
	mat future diffuseColor: #(1 1 1 0.99) asFloatArray.
	mat future emissiveColor: #(1 1 1 0.99) asFloatArray.

	txtr future material: mat.

	aPosition := avatar translation - (avatar lookAt * 10).
	wnd := self makeWindow.
	wnd future contents: txtr.
	wnd future translation: aPosition.
	wnd future rotationAroundY: avatar yaw.
	space future addChild: wnd.
! !

!CroquetHarness methodsFor: 'embedded apps' stamp: 'ar 7/18/2006 13:22'!
embeddedApps
	^embeddedApps! !

!CroquetHarness methodsFor: 'embedded apps' stamp: 'ar 7/18/2006 11:06'!
embeddedApps: aCollection
	embeddedApps := aCollection! !

!CroquetHarness methodsFor: 'islands' stamp: 'ar 1/15/2006 18:23'!
enableIslandCache
	^enableIslandCache! !

!CroquetHarness methodsFor: 'islands' stamp: 'ar 1/15/2006 18:23'!
enableIslandCache: aBool
	enableIslandCache := aBool.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'das 4/25/2006 20:48'!
eventPointer

	^ eventPointer.! !

!CroquetHarness methodsFor: 'islands' stamp: 'sn 2/25/2018 16:13'!
findContactByPostcard: pc
	| contact |

	contactPoint ifNil:[contactPoint := TContactPointWS new].
	pc routerAddress ifNil:["indicates that this is a LAN contact"
		"Grab most recent contact"
		pc routerID ifNotNil:["first by ID"
			contact := contactPoint contactsByID at: pc routerID ifAbsent:[nil].
		].
		contact ifNil:["then by name"
			contact := contactPoint contactsByName at: pc routerName ifAbsent:[nil].
		].
		contact ifNil:[^nil]. "still waiting for a contact"

		contact setupContact.
		self addController: contact controller.
		self addIsland: contact controller island postcard: pc.
		^ contact controller island.
	] ifNotNil:[
		"go out and find the contact on the WAN"
	].
	^ nil.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 9/21/2006 17:31'!
findController: aBlock
	"Find a controller matching the given block"
	^controllers detect: aBlock ifNone:[nil].! !

!CroquetHarness methodsFor: 'islands' stamp: 'das 1/19/2006 12:38'!
findIslandByPostcard: pc
	| island |

	island := islandsByID at: pc routerID ifAbsent:[nil].
	island ifNil:[island := islandsByName at: pc routerName ifAbsent:[nil]].
	^ island.! !

!CroquetHarness methodsFor: 'islands' stamp: 'ar 3/13/2006 17:01'!
findViewpointByPostcard: pc

	| island rval |
	"Find the island"
	island := self findIslandByPostcard: pc.
	island ifNil:["if not here, try to find it on the net"
		postcard := pc copy.
		^nil].
	"Try to resolve by viewpoint ID"
	pc viewpointID ifNotNil:[
		rval := island send:[ :isl | isl lookup: pc viewpointID].
		rval ifNotNil:[^rval asFarRef].
	].
	"Otherwise use viewpoint name"
	rval := island send:[ :isl | isl at: pc viewpointName].
	^ rval ifNotNil:[rval asFarRef].
! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 2/3/2006 00:12'!
formManager
	^formMgr! !

!CroquetHarness methodsFor: 'accessing' stamp: 'das 4/6/2006 12:37'!
gotoSnapshot: snap
	| pc sp tfm vp |
	pc := snap postcard.
	pc ifNil:[
		sp := snap space.
		tfm := snap globalTransform.
	] ifNotNil:[
		vp := self findViewpointByPostcard: pc.
		sp := (vp get: #root) ifNil:[^nil].
		tfm := vp get: #globalMatrixOut.
	].
	avatar newTransform: tfm.
	avatar newPostcard: (sp get: #postcard).! !

!CroquetHarness methodsFor: 'initialize' stamp: 'ar 11/13/2006 14:23'!
initialize
	| seed |
	"Not really needed but a good thing to do for sanity checks and testing"
	FileDirectory addCroquetMimeTypes.
	"Make sure the current island's random is properly seeded"
	seed := ByteArray new: 128.
	(TCryptoRandom gatherEntropy: seed) ifFalse:[
		"Raise a warning about the poor quality of entropy"
		self inform: ' 
WARNING: SECURITY PROBLEM DETECTED!!
 
This platform (', Smalltalk platformName, ') appears to have no good source
of entropy available. Since this DRAMATICALLY lowers the
quality of encryption we recommend bugging the platform
maintainer to work with the Croquet team to fix this problem.
 '.
	].
	Island default randomStream seedVector: seed.
	formMgr := self initializeFormManager.
	cacheMgr := formMgr cacheManager. "share it"
	enableIslandCache := false.
	controllers := OrderedCollection new.
	islandsByName := Dictionary new.
	islandsByID := Dictionary new.
	doRender := false.
	readyToRender := Semaphore new.
	overlays := #().
	eventPointer := TPointer new.
	redButtonPressed := false.
	yellowButtonPressed := false.
	snapshots := OrderedCollection new.
	userID := (TObjectID for: 'User').
	event := CroquetEvent new.
	event userID: userID.
	allowControllerAliasing := false.
	self initializeAvatar.
	self setupLocal.
	task := TTaskMain new.
	task harness: self.
	embeddedApps := Dictionary new.! !

!CroquetHarness methodsFor: 'initialize' stamp: 'ar 11/13/2006 14:24'!
initializeAvatar
	avatar := TAvatarUser new.
	avatar userID: userID.
	avatar harness: self.
	avatar snapshots: snapshots.
	avatar loadAvatar: 'Content/Avatars/WhiteRabbit.mdl'.
! !

!CroquetHarness methodsFor: 'initialize' stamp: 'ar 10/7/2006 15:36'!
initializeFormManager
	"Initialize the form manager. Subclasses may override this method to provide other form managers."
	TFormManager default destroy.
	TFormManager default: nil.
	^TFormManager default.
! !

!CroquetHarness methodsFor: 'event handling' stamp: 'ar 7/17/2006 20:16'!
keyDown: anEvent

	event timeStamp: anEvent timeStamp.
	event buttons: anEvent buttons.
	event keyValue: anEvent keyValue.
	event avatar: avatar replica.
	event shiftPressed: anEvent shiftPressed.
	event controlKeyPressed: anEvent controlKeyPressed.
	event selection: eventPointer selection.
"if we are pointing to something then send the event to that, otherwise send to avatar"

	eventPointer selectedTarget ifNotNil:[
		(task doKeyDown: event)ifTrue:[ ^ self. ].
	].

	avatar keyDown: event.	! !

!CroquetHarness methodsFor: 'event handling' stamp: 'ar 9/7/2006 11:26'!
keyStroke: anEvent

	| controlWasPressed shiftWasPressed |
	"XXXX: FIXME: Use the control and shift key bit from the last event to make 
	scroll wheel events work correctly with those keys."
	shiftWasPressed := event shiftPressed.
	controlWasPressed := event controlKeyPressed.
		event buttons: anEvent buttons.
		event keyValue: anEvent keyValue.
		event avatar: avatar replica.
		event selection: eventPointer selection.
	event controlKeyPressed: controlWasPressed.
	event shiftPressed: shiftWasPressed.
"if we are pointing to something then send the event to that, otherwise send to avatar"

	eventPointer selectedTarget ifNotNil:[
		(task doKeyStroke: event)ifTrue:[^ self.].
	].

	avatar keyStroke: event.	! !

!CroquetHarness methodsFor: 'event handling' stamp: 'ar 7/17/2006 20:16'!
keyUp: anEvent

	event timeStamp: anEvent timeStamp.
	event buttons: anEvent buttons.
	event keyValue: anEvent keyValue.
	event avatar: avatar replica.
	event shiftPressed: anEvent shiftPressed.
	event controlKeyPressed: anEvent controlKeyPressed.

"if we are pointing to something then send the event to that, otherwise send to avatar"

	eventPointer selectedTarget ifNotNil:[
		(task doKeyUp: event) ifTrue:[ ^ self. ].
	].

	avatar keyUp: event.

	! !

!CroquetHarness methodsFor: 'initialize' stamp: 'das 11/14/2005 08:43'!
loadFrame: fileName orCreate: aClass
	"Try to load the dungeon from cache"
	| file island portal reader info label bar |
	info := 'Loading ', fileName.
	label := StringMorph new contents: info.
"	self addMorphFront: label."
"	label position: self position."
	bar := [:aString| label contents: aString. World doOneCycleNow].

	file := [FileStream readOnlyFileNamed: fileName] 
			on: FileDoesNotExistException 
			do:[:ex| ex return: nil].
	file ifNotNil:[
		[
			reader := TIslandReader new.
			reader progressBar: bar.
			reader defaultInfo: info.
			island := [reader readObjectFrom: file] 
				on: Error do:[:ex| ex return: nil].
			island ifNotNil:[
				portal := island portal. 	
			].
		] ensure:[file close].
	].
	portal ifNil:["no cached version - recreate from scratch"
		island := TIsland new.
		island scheduler: (island new: ScriptScheduler).
		island name: aClass name.
		portal := island new: aClass.
		island portal: portal.
		file := FileStream forceNewFileNamed: fileName.
		[	
			self saveIsland: island on: file. 
		] ensure:[
			file close.
		].
	].
	label delete.
	^portal.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 3/13/2006 12:59'!
makeSnapshot
	"Make a snapshot at the current location."
	^self makeSnapshot: self activeSpace angle: avatar yaw translation: avatar translation! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 2/2/2006 23:11'!
makeSnapshot: space angle: yval translation: t
	| trans snapshot |
	trans := Matrix4x4 identity.
	trans rotationAroundY: yval.
	trans translation: t.
	snapshot := TSnapshot new space: space transform: trans.
	snapshots add: snapshot.! !

!CroquetHarness methodsFor: 'messages' stamp: 'das 7/5/2006 13:15'!
makeWindow
	windowData ifNil:[windowData := TIslandCopier new export: TWindow new].
	^TIslandCopier new import: windowData to: self activeSpace island.! !

!CroquetHarness methodsFor: 'event handling' stamp: 'ar 7/17/2006 20:17'!
mouseDown: evt

	event timeStamp: evt timeStamp.
	event shiftPressed: evt shiftPressed.
	event controlKeyPressed: evt controlKeyPressed.
" test for moving "
	(evt controlKeyPressed not and:[evt yellowButtonChanged]) ifTrue:[ 
		yellowButtonPressed := true.
		avatar mouseDown: evt.
	].
" test for object selection "
	evt redButtonChanged ifTrue:[
		avatar updateCamera: ogl camera.
		lastCameraTransform:= ogl camera globalTransform copy.
		redButtonPressed := true.
		eventPointer pointerDown: true.
		self pointerXY: evt position.
		event buttons: evt buttons.
		event keyValue: 0.
		event avatar: avatar replica.
		event camera: ogl camera.
		event selection: eventPointer selection.
		task doPointerDown: event.
	].

! !

!CroquetHarness methodsFor: 'event handling' stamp: 'ar 7/17/2006 20:17'!
mouseMove: evt

	|  newCameraTransform |
	self pointerXY: evt position.
	event timeStamp: evt timeStamp.
	event shiftPressed: evt shiftPressed.
	event controlKeyPressed: evt controlKeyPressed.
	yellowButtonPressed ifTrue:[
		avatar mouseMove: evt.
	].

	redButtonPressed ifTrue:[
		eventPointer pointerDown ifTrue: [
			avatar updateCamera: ogl camera.
			newCameraTransform := ogl camera globalTransform copy.
			eventPointer selectedRayTransform: eventPointer localTransform.
			eventPointer isOverlay ifFalse:[
				eventPointer selectedCameraTransform ifNotNil:[
					eventPointer selectedCameraTransform: lastCameraTransform orthoNormInverse * 					newCameraTransform * eventPointer selectedCameraTransform.
				]
			].
			lastCameraTransform := newCameraTransform.
"			eventPointer selectedCameraTransform: ogl camera globalTransform copy."
			avatar laserControl:  eventPointer redButton: redButtonPressed.

			event buttons: evt buttons.
			event shiftPressed: evt shiftPressed.
			event keyValue: 0.
			event camera: ogl camera.
			event avatar: avatar replica.
			event selection: eventPointer selection.

			task doPointerMove: event.
		].
	].! !

!CroquetHarness methodsFor: 'event handling' stamp: 'ar 7/17/2006 20:17'!
mouseUp: evt

	event timeStamp: evt timeStamp.
	event shiftPressed: evt shiftPressed.
	event controlKeyPressed: evt controlKeyPressed.
	evt yellowButtonChanged ifTrue:[
		yellowButtonPressed := false.
		avatar mouseUp: evt.
	].
	evt redButtonChanged ifTrue:[
		eventPointer pointerDown ifTrue:[
			eventPointer pointerDown: false.
			(eventPointer selectedEventMask anyMask:TFrame eventPointerDown) ifTrue:[
				avatar laserControl:  eventPointer redButton: false.
				event buttons: evt buttons.
				event shiftPressed: evt shiftPressed.
				event keyValue: 0.
				event avatar: avatar replica.
				event selection: eventPointer selection.
				event camera: ogl camera.
				task doPointerUp: event.
"after a #doPointerUp: we sent a #doPointerLeave: and force a pointer reset. This allows others to grab the object"
				task doPointerLeave: event.
				eventPointer resetTotal.
			].
		].
		redButtonPressed := false.
	].
! !

!CroquetHarness methodsFor: 'private' stamp: 'ar 7/8/2006 18:02'!
myEventMap
	^myEventMap! !

!CroquetHarness methodsFor: 'private' stamp: 'ar 7/8/2006 18:02'!
myEventMap: aMap
	myEventMap := aMap! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/7/2006 19:56'!
ogl
	^ogl! !

!CroquetHarness methodsFor: 'event handling' stamp: 'das 3/14/2006 20:37'!
pointerXY: pxy

	ogl ifNil:[^self].
	eventPointer localTransform: (ogl camera pointerXY: pxy).
	avatar speedControl: (bounds center - pxy) / (bounds extent * 0.5) 
			pointer:  eventPointer redButton: redButtonPressed.
! !

!CroquetHarness methodsFor: 'accessing' stamp: 'das 4/24/2006 13:45'!
popTask

	task := taskStack removeLast.
! !

!CroquetHarness methodsFor: 'accessing' stamp: 'das 4/24/2006 13:45'!
pushTask: newTask

	taskStack ifNil:[taskStack := OrderedCollection new.].
	taskStack add: task.
	task := newTask.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 5/24/2006 15:51'!
removeController: aController
	controllers remove: aController ifAbsent:[].! !

!CroquetHarness methodsFor: 'render' stamp: 'sn 3/1/2018 00:59'!
render
	doRender ifFalse:[^nil].
	ogl ifNil:[^nil].
	ogl forcePick: (ogl forcePick or:[task forcePick]).
	renderProcess ifNotNil:[^readyToRender signal]. "avoid recursive calls"
	readyToRender initSignals.
	renderProcess := self croquetFork: #renderProcess at: Processor activePriority+1. 
	readyToRender signal.
	readyToRender waitTimeoutMSecs: 1000. "at most one sec"
	ogl forcePick: false.
! !

!CroquetHarness methodsFor: 'render' stamp: 'ar 1/19/2006 14:03'!
renderProcess
	doRender ifFalse:[
		readyToRender signal.
		^renderProcess := nil.
	].
	[self renderWorld] ensure:[
		readyToRender signal.
		renderProcess := nil.
	].! !

!CroquetHarness methodsFor: 'render' stamp: 'das 5/1/2006 18:48'!
renderSnapshot: snapshot
	"Update the snapshot"
	| delta sp pc tfm vp |
	pc := snapshot postcard.
	pc ifNil:[
		sp := snapshot space.
		sp isResolved ifFalse:[^nil]. "don't even try"
		tfm := snapshot globalTransform.
	] ifNotNil:[
		vp := self findViewpointByPostcard: pc.
		vp isResolved ifFalse:[^nil].
		sp := (vp get: #root) ifNil:[^nil].
		tfm := vp get: #globalMatrixOut.
	].
	ogl camera: TCamera new.
	ogl camera bounds: snapshot bounds.
	ogl camera initFrustum: ogl.
	ogl camera localTransform: tfm.
	sp renderView: ogl overlay: #().
	ogl camera killFrame: true.
	delta := bounds height - snapshot bounds height.
	snapshot form: (ogl screenShot: (ogl camera bounds translateBy: 0 @ delta)).! !

!CroquetHarness methodsFor: 'render' stamp: 'sn 2/25/2018 15:46'!
renderWorld
	| mutexSet oldCam randomList |

	avatar newPostcard  ifNil:[
		"@@@@ FIXME: This is screwed up - we should really know which space we're in @@@@"
		avatar currentSpace == self activeSpace
			ifFalse:[
				avatar addToNewSpace: self activeSpace.
				avatar updateCamera: ogl camera.
			].
	] ifNotNil:[
		avatar addToNewSpace: (avatar newPostcard resolveViewpoint:ogl).
"@@@@ FIXME: This is screwed up, too - the following should use a proper future send not an immediate #send:. @@@@"
		viewPortal send:[ :vp | vp postcardLink: avatar newPostcard.].
		avatar newPostcard:nil.
		avatar updateCamera: ogl camera.
	"	ogl camera localTransform: avatar globalTransform."
	].

	"We use activeSpace (the instance variable) only as memory
	 to detect space transitions. If activeSpace has changed, signal the event."

	(activeSpace ~= self activeSpace) ifTrue: [
		activeSpace := self activeSpace.
		self signal: #activeSpaceChanged with: activeSpace.
	].

	mutexSet := TMutexSet withAll: (controllers collect:[:cc| cc mutex]).
	mutexSet critical:[
		readyToRender wait.
		"Temporarily, force any attempt to creat OIDs to fail"
		randomList := (controllers select:[:cc| cc island notNil]) 
			collect:[:cc| cc island -> (cc island get: #randomStream)].
		randomList do:[:a| a key send:[:x| x randomStream: nil]].
		ogl ifNotNil:[
			formMgr updateList: ogl.
			avatar updateCamera: ogl camera.
			avatar driveStep.
			self aboutToRender.
			ogl makeCurrent.
			ogl glLoadIdentity.
			event avatar: avatar replica.
			event camera: ogl camera.
			eventPointer resetSelected: event.
			ogl eventPointer: eventPointer.
			(redButtonPressed and:[task noPickWhileDown])ifTrue:[
				eventPointer selection target ifNotNil:[
					eventPointer selectedRayTransform: eventPointer localTransform.
					eventPointer selection target send:[ :tgt | tgt pickSelf: ogl .].
				].
				ogl eventPointer: nil.
			].
			viewPortal send:[ :vp | vp renderView: ogl with:{systemOverlayPortal}.].
			overlays do:[:each| each renderOverlay: ogl].
			ogl swapBuffers.
			"render snapshots"
			oldCam := ogl camera.
			snapshots do:[:snap| 
				snap update ifTrue:[self renderSnapshot: snap]].
			ogl camera: oldCam.
			ogl camera initFrustum: ogl.
		].
		randomList do:[:a| a key send:[:x| x randomStream: a value]].
	 ].
	ogl eventPointer: eventPointer.
! !

!CroquetHarness methodsFor: 'islands' stamp: 'das 10/3/2005 00:24'!
saveIsland: island on: file
	| writer |
	writer := TIslandWriter new.

	"Prepare the project for saving"
	island portal signal: #shutDownIsland with: false.
	island scheduler run.
	"Checkpoint project"
	Cursor wait showWhile:[
		[writer snapshot: island] ensure:[
			"Start the project again"
			island project signal: #startUpProject with: false.
		].
	].
	writer failed ifTrue:[^self inform: 'Checkpoint failed'].
	Cursor write showWhile:[writer saveObjectOn: file].
	island croquet: self.
! !

!CroquetHarness methodsFor: 'initialize' stamp: 'sn 2/23/2018 23:50'!
setupLocal
	| localController sop |

	localController := TLocalController new.
	localController join. 	"request messages"
	localController heartbeat: 20.
	self addController: localController.
	systemIsland := localController newIsland.

	"make a portal inside the local island"
	viewPortal := systemIsland future new: TPortal.
	systemIsland future at: #portal put: viewPortal.

	"make system overlay inside the local island"
	systemOverlay := systemIsland future new: TSystemSpace.
	systemOverlayPortal := systemIsland future new: TPortal.
	sop := systemOverlay future postcard.

	sop whenResolved:[
		
		systemOverlayPortal future postcardLink: sop value.
		self addIsland: systemIsland postcard: sop value.
	].
"	island future at: #systemOverlay put: systemOverlay."
	postcard := TPostcard new routerAddress: nil "don't know what it is"
				id: nil "don't know what it is"
				name: 'Master' 
				viewpointName: #masterSpace.
	viewPortal future postcardLink: postcard.! !

!CroquetHarness methodsFor: 'initialize' stamp: 'sn 2/24/2018 17:12'!
setupMaster
	| space sync island portal spc pc rportal rpc portal3D rspace rspc rIsland |

	island := self createIsland: SimpleWorld named: 'Master'.

	space := island future at: #masterSpace.
	portal := island future at:#portal1.
	portal3D := island future at:#portal3D.
	spc := space future postcard.
	pc := portal future postcard.
	
	spc whenResolved:[
		self addIsland: island postcard: spc value.
		


	rIsland := self createIsland: RecurseWorld named: 'Recurse'.
	rspace := rIsland future at: #recurseSpace.
	rspc := rspace future postcard.
	
	rportal := rIsland future at: #portal1.
	
	rpc := rportal future postcard.

	pc whenResolved:[
		rpc whenResolved:[
			self addIsland: rIsland postcard: rpc value.
			portal future postcardLink: rpc value.
			rportal future postcardLink: pc value.
		].
	].

	rspc whenResolved:[
		portal3D future postcardLink: rspc value.
	].



	sync := viewPortal future postcardLink: spc value.
		sync whenResolved:[doRender := true]. "ready to render"

	]
! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 2/2/2006 23:25'!
snapshots
	^snapshots! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 2/2/2006 23:25'!
snapshots: aCollection
	snapshots := aCollection.! !

!CroquetHarness methodsFor: 'render' stamp: 'ar 1/7/2006 17:07'!
startRender
	"Start rendering"
	doRender := true.! !

!CroquetHarness methodsFor: 'messages' stamp: 'sn 2/25/2018 17:50'!
step
	| island |

	postcard ifNotNil:[

		island := self findIslandByPostcard: postcard.
		island ifNil:[island := self findContactByPostcard: postcard.].
		island ifNotNil:[
			postcard := nil.
			doRender ifFalse:[self startRender].
		].
	].

	"Yield the processor to the O.S. at least once per frame;
	 this allows background processes (e.g. Gecko) to get at least a few cycles."
	ProcessorScheduler relinquishProcessorForMicroseconds:1000.

	renderProcess ifNil:[
		controllers do:[:each| each critical:[each processMessages]].
	].

	(Smalltalk platformName = 'Win32') ifTrue: [
		ProcessorScheduler relinquishProcessorForMicroseconds: 1000.
	].
	formMgr step.
	avatar updateUser.
! !

!CroquetHarness methodsFor: 'render' stamp: 'ar 1/7/2006 17:07'!
stopRender
	"Stop rendering"
	doRender := false.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'das 3/7/2006 13:18'!
systemIsland

	^ systemIsland.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'das 3/7/2006 13:15'!
systemOverlay

	^ systemOverlay.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'das 5/8/2006 03:35'!
updateCamera

	avatar updateCamera: ogl camera.
! !

!CroquetHarness methodsFor: 'embedded apps' stamp: 'ar 7/18/2006 11:55'!
updateEmbeddedApp: appRef
	| appName appClass appID app |
	appID := appRef get: #appID.
	(self embeddedApps includesKey: appID) ifTrue:[^self]. "app already exists"
	appName := appRef get: #appName.
	appClass := TEmbeddedApp appNamed: appName.
	Transcript cr; show: 'Instantiating new ', appName asString, ' (', appClass name, ')'.
	appClass ifNotNil:[
		app := appClass instantiateEmbeddedApp: appRef.
	].
	app ifNil:[
		Transcript cr; show: 'WARNING: No app created for ', appName asString.
	] ifNotNil:[
		app userID: userID.
		self embeddedApps at: appID put: app
	].
! !

!CroquetHarness methodsFor: 'embedded apps' stamp: 'ar 9/8/2006 09:26'!
updateEmbeddedAppsIn: anIsland
	"Update the embedded apps in the given island"
	| apps |
	anIsland ifNil:[^nil].
	"Transcript cr; show: 'Embedded app update request for ', anIsland."
	apps := anIsland future at: #embeddedApps.
	apps whenResolved:[
		"Transcript cr; show: 'Embedded apps: ', apps value."
		apps value ifNotNil:[apps value do:[:appRef| self updateEmbeddedApp: appRef]].
	].
	self runScript: #updateEmbeddedAppsIn: when:{anIsland. #updateEmbeddedApps}.! !

!CroquetHarness methodsFor: 'accessing' stamp: 'ar 1/7/2006 17:07'!
viewPortal
	^viewPortal! !

Morph subclass: #CroquetParticipant
	instanceVariableNames: 'harness lastBounds'
	classVariableNames: 'DefaultForm'
	poolDictionaries: 'OpenGLConstants'
	category: 'Croquet-Harness'!

!CroquetParticipant commentStamp: 'das 4/22/2005 16:58' prior: 0!
CroquetMorph is currently the jumping off point for Croquet. We use Morphic to handle low-level events and communicate with Squeak. At some point, this dependency will change.

DAS!

CroquetParticipant subclass: #CroquetMaster
	instanceVariableNames: 'contactBroadcaster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Harness'!

!CroquetMaster commentStamp: 'das 4/3/2006 02:03' prior: 0!
A simple Morph used to manage a minimal version of Croquet.!

!CroquetMaster class methodsFor: 'parts bin' stamp: 'das 10/10/2005 16:23'!
descriptionForPartsBin
	^ self partName:	'Croquet(Master)'
		categories:		#('Croquet')
		documentation:	'Croquet Master Browser - this creates a new Croquet world'
		sampleImageForm: self defaultForm.
! !

!CroquetMaster methodsFor: 'as yet unclassified' stamp: 'sn 2/25/2018 18:46'!
delete
	super delete.
	contactBroadcaster ifNotNil:[
		contactBroadcaster stopBroadcaster
		].! !

!CroquetMaster methodsFor: 'initialization' stamp: 'sn 2/25/2018 18:45'!
setup

	harness := CroquetHarness new.
	contactBroadcaster := TBroadcasterStandalone reset default.
	harness setupMaster.
	harness addOverlay: self.! !

!CroquetParticipant class methodsFor: 'as yet unclassified' stamp: 'das 4/22/2005 17:27'!
defaultForm

	^DefaultForm ifNotNil:[DefaultForm] ifNil:[DefaultForm := Form extent: 64@64 depth: 32 bits: (Base64MimeConverter mimeDecode:
   '8AAS/wAAAQf/AQEBFv8AAAEH/wABARL/AAABB/8BAAEK/wAAAQf/AAEBCv8AAAEH/wARAAr/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' as: String) asByteArray].! !

!CroquetParticipant class methodsFor: 'as yet unclassified' stamp: 'das 10/10/2005 16:21'!
descriptionForPartsBin
	^ self partName:	'Croquet(Participant)'
		categories:		#('Croquet')
		documentation:	'Croquet Participant Browser - this uses someone else Croquet world'
		sampleImageForm: self defaultForm.
! !

!CroquetParticipant methodsFor: 'menu' stamp: 'das 4/22/2005 21:10'!
addCustomMenuItems: aMenu hand: aHand
	super addCustomMenuItems: aMenu hand: aHand.
	aMenu addUpdating: #showFrameRateString action: #toggleFrameRate.
	aMenu add: 'toggle full screen' action: #toggleFullScreen.
! !

!CroquetParticipant methodsFor: 'drawing' stamp: 'ar 1/19/2006 15:13'!
areasRemainingToFill: aRectangle
	^aRectangle areasOutside: self bounds! !

!CroquetParticipant methodsFor: 'Morphic render' stamp: 'ar 2/24/2006 14:51'!
beginMorphicOverlay: ogl
	"Set up gl to provide overlay drawing - this is done in pixel coordinates"
	ogl glMatrixMode: GLProjection.
	ogl glPushMatrix.
	ogl glLoadIdentity.
	ogl glMatrixMode: GLModelview.
	ogl glPushMatrix.
	ogl glLoadIdentity.
	ogl glTranslated: -1 with: 1 with: 0.0.
	ogl glScaled: (2.0 / bounds width) with: (-2.0 / bounds height) with: 1.0.
	ogl glDisable: GLDepthTest.
	ogl glEnable: GLBlend.
	ogl glBlendFunc: GLOne with: GLOneMinusSrcAlpha.

! !

!CroquetParticipant methodsFor: 'initialization' stamp: 'das 4/29/2005 10:18'!
collapse
! !

!CroquetParticipant methodsFor: 'initialization' stamp: 'ar 11/9/2005 12:20'!
delete
	harness ifNotNil:[harness destroy].
	super delete.
! !

!CroquetParticipant methodsFor: 'drawing' stamp: 'ar 1/19/2006 17:21'!
drawOn: aCanvas

	(harness == nil or:[harness doRender not]) ifTrue:["still waiting for connection"
		super drawOn: aCanvas.
		^aCanvas drawString: 'Waiting for connection...' at: bounds origin.
	].
	lastBounds ~= self bounds ifTrue:[
		lastBounds := self bounds.
		harness bounds: self bounds.
	].
	harness render.
	Display addExtraRegion: bounds for: self.! !

!CroquetParticipant methodsFor: 'drawing' stamp: 'ar 1/6/2006 22:26'!
drawSubmorphsOn: aCanvas
	"ignore"! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'ar 1/6/2006 19:45'!
dropFiles: anEvent
	"Handle a number of dropped files from the OS."
	| numFiles stream |
	numFiles := anEvent contents.
	1 to: numFiles do: [:i |
		stream := FileStream requestDropStream: i.
		[harness dropFile: stream] ensure:[stream close].
	].! !

!CroquetParticipant methodsFor: 'Morphic render' stamp: 'ar 1/6/2006 22:29'!
endMorphicOverlay: ogl
	"Set up gl to provide overlay drawing - this is done in pixel coordinates"
	ogl glDisable: GLBlend.
	ogl glMatrixMode: GLModelview.
	ogl glPopMatrix.
	ogl glMatrixMode: GLProjection.
	ogl glPopMatrix.
	ogl glMatrixMode: GLModelview.
! !

!CroquetParticipant methodsFor: 'drawing' stamp: 'ar 1/19/2006 17:16'!
forceToScreen
	"Ignore. We handle buffer swaps in the renderer."
"Time millisecondClockValue printString displayAt: 0@0.
Display forceToScreen: (0@0 corner: 100@15)."! !

!CroquetParticipant methodsFor: 'menu' stamp: 'das 4/22/2005 21:09'!
fpsMorph
	^self valueOfProperty: #fpsMorph! !

!CroquetParticipant methodsFor: 'menu' stamp: 'das 4/23/2005 11:11'!
fpsMorph: aMorph
	^self setProperty: #fpsMorph toValue: aMorph! !

!CroquetParticipant methodsFor: 'Morphic render' stamp: 'ar 1/6/2006 22:30'!
glRenderMorphicOverlayOn: aRenderer 
	"Display submorphs back to front"
	submorphs size = 0 ifTrue:[^self].
	submorphs reverseDo:[:sm| sm glRenderOn: aRenderer].
! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 12/9/2005 12:03'!
handleMouseMove: anEvent
	"Reimplemented to get #mouseOver: messages"
	self mouseOver: anEvent.
	super handleMouseMove: anEvent.! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 12/9/2005 12:03'!
handlesKeyboard: evt

	^ true
! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 12/9/2005 12:03'!
handlesMouseDown: evt
	^ true.
	"evt yellowButtonPressed ifTrue: [^false] ifFalse: [^true]."
! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 12/9/2005 12:03'!
handlesMouseOver: evt

^ true.! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 12/9/2005 12:03'!
handlesMouseStillDown: evt

^ true.! !

!CroquetParticipant methodsFor: 'drawing' stamp: 'ar 1/15/2006 01:11'!
imageForm
	^harness ogl
		ifNil: [super imageForm]
		ifNotNil: [harness ogl screenShot]! !

!CroquetParticipant methodsFor: 'initialization' stamp: 'das 3/29/2006 12:13'!
initialize

	super initialize.
	self clipSubmorphs: true.
	self color: (Color
				r: 1.0
				g: 0.0
				b: 0.0).
	self extent: 640@480.
	self setProperty: #suppressStepping toValue: true.! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'ar 1/31/2006 10:05'!
justDroppedInto: aMorph event: anEvent
	super justDroppedInto: aMorph event: anEvent.
	World doOneCycleNow.
	self removeProperty: #suppressStepping.
! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'ar 1/15/2006 18:10'!
keyDown: anEvent
	harness ifNil:[^nil].
	harness keyDown: anEvent.

	! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 12/9/2005 12:10'!
keyStroke: anEvent

	harness keyStroke: anEvent.

	! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'ar 1/15/2006 18:09'!
keyUp: anEvent
	harness ifNil:[^nil].
	harness keyUp: anEvent.

	! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 2/3/2006 23:35'!
mouseDown: evt

	evt setPosition: evt position - self bounds topLeft.
	harness mouseDown: evt.
! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 12/9/2005 13:29'!
mouseEnter: evt

	evt setPosition: evt position - self bounds topLeft.
	evt hand newKeyboardFocus: self.! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 12/9/2005 13:29'!
mouseMove: evt

	evt setPosition: evt position - self bounds topLeft.
	harness mouseMove: evt.! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 5/1/2006 20:55'!
mouseOver: evt
	harness ifNil:[^nil].
	harness pointerXY: evt position - self bounds topLeft.
! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'das 2/3/2006 23:35'!
mouseUp: evt

	evt setPosition: evt position - self bounds topLeft.
	harness mouseUp: evt.
! !

!CroquetParticipant methodsFor: 'initialization' stamp: 'ar 1/15/2006 18:08'!
openInWorld
	super openInWorld.
	World doOneCycleNow.
	self removeProperty: #suppressStepping.
! !

!CroquetParticipant methodsFor: 'Morphic render' stamp: 'ar 2/3/2006 00:13'!
renderMorphic: ogl
	"Set up gl to provide overlay drawing - this is done in pixel coordinates"
	| sz |
	ogl glDisable: GLLighting.
	self beginMorphicOverlay: ogl.
	sz := harness formManager findCount.
	sz > 0 ifTrue:[
		ogl drawString: 'Textures to load: ', sz printString
			at: 0@0@0 font: nil color: Color orange align: #topLeft].
	self glRenderMorphicOverlayOn: ogl.
	self endMorphicOverlay: ogl.
	ogl glEnable: GLLighting.
! !

!CroquetParticipant methodsFor: 'Morphic render' stamp: 'ar 1/6/2006 22:36'!
renderOverlay: ogl
	self renderMorphic: ogl.! !

!CroquetParticipant methodsFor: 'initialization' stamp: 'ar 1/6/2006 22:37'!
setup
	"Try to set me up based on the master router"
	harness := CroquetHarness new.
	harness addOverlay: self.! !

!CroquetParticipant methodsFor: 'menu' stamp: 'das 4/22/2005 21:10'!
showFrameRateString
	^(self fpsMorph ifNil:['<off>'] ifNotNil:['<on>']), 'show frame rate'! !

!CroquetParticipant methodsFor: 'stepping and presenter' stamp: 'das 7/5/2006 17:02'!
step

	super step.
	(self hasProperty: #suppressStepping) ifFalse:[
		[harness 
			ifNil:[self setup]
			ifNotNil:[harness step].
		] ensure:[(self isInWorld and:[self isStepping not]) ifTrue:[self startStepping]].
	].
	self changed.! !

!CroquetParticipant methodsFor: 'stepping and presenter' stamp: 'das 7/4/2005 17:33'!
stepTime
	^Preferences higherPerformance ifTrue: [1] ifFalse: [20]! !

!CroquetParticipant methodsFor: 'menu' stamp: 'das 4/23/2005 11:12'!
toggleFrameRate
	self fpsMorph: (self fpsMorph ifNil:[FrameRateMorph new] ifNotNil:[nil])! !

!CroquetParticipant methodsFor: 'menu' stamp: 'das 4/22/2005 21:08'!
toggleFullScreen
	ScreenController lastScreenModeSelected
		ifTrue:[
			| priorBounds |

			priorBounds := self
								valueOfProperty: #priorBounds
								ifAbsent:[0 @ 0 corner: 640 @ 480].
			self bounds: priorBounds.
			self removeProperty: #priorBounds.

			ScreenController new fullScreenOff.
			self world positionSubmorphs.
		]
		ifFalse:[	
			ScreenController new fullScreenOn.
			self world positionSubmorphs.

			self setProperty: #priorBounds toValue: self bounds.
			self bounds: self world bounds.
			self comeToFront.
		].
! !

!CroquetParticipant methodsFor: 'event handling' stamp: 'ar 1/6/2006 19:44'!
wantsDropFiles: anEvent
	"Return true if the receiver wants files dropped from the OS."
	^true! !

!CroquetParticipant methodsFor: 'stepping and presenter' stamp: 'das 7/4/2005 17:33'!
wantsSteps
	^true! !
CroquetHarness initialize!
